 /*
 * file      : src/file.c
 * project   : tm
 * with      : Gtk-2
 *
 * copyright : (C) 2012 by Claude BULIN
 *
 * TM - Edition des heures de travail / Edition of working hours
 * GNU General Public License
 * 
 * This file is part of TM.
 * 
 * TM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 * 
 * TM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with TM.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifdef HAVE_CONFIG_H
	#include "../config.h"
#endif

#ifdef ENABLE_NLS
	#include <libintl.h>
	#define _(String) gettext (String)
	#define gettext_noop(x) (x) 
#endif

#include <gtk/gtk.h>
#include <string.h>
#include <stdlib.h>

#ifdef ENABLE_STATIC_LIBRARY
	#include "../lib_tm/lib.h"
#endif

#include "global.h"
#include "callbacks.h"
#include "configuser.h"
#include "win_info.h"



// 
// STOCKAGE DE HEURES SUPLEMENTAIRES PAR SEMANE
//	HEURES SUPERIEURE A HEURES_NORMALES_SEMAINE
// 
void file_get_overtime( void )
{
	gint	Day;
	gint	S = 0;
	
	// INIT
	for( Day = 0; Day < VarEdit.NbrJoursAnnee; Day ++ ) {
		VarEdit.Day[ Day ].WorkingTime = 0;
		VarEdit.Day[ Day ].OverTime    = 0;
	}
	// 
	for( Day = 0; Day < VarEdit.NbrJoursAnnee; Day ++ ) {
		
		// HEURES DE LA JOURNEE
		S += (VarEdit.Day[ Day ].MatinFin - VarEdit.Day[ Day ].MatinDebut) + (VarEdit.Day[ Day ].SoirFin - VarEdit.Day[ Day ].SoirDebut);
		
		if( VarEdit.Day[ Day ].ThisDay == 7 ) {
			// HEURES DE LA SEMAINE
			VarEdit.Day[ Day ].WorkingTime = S;
			// SEMAINE MOINS HEURES_NORMALES_SEMAINE
			// if( S >= 2220 )
			// 	VarEdit.Day[ Day ].OverTime = S - 2220;
			if( S >= Config.TimeByWeek )
				VarEdit.Day[ Day ].OverTime = S - Config.TimeByWeek;
			// RE-INIT
			S = 0;
		}
	}
}
// 
// 
// 
// 
gdouble file_test_is_new_page( gdouble p_PosY, gint *p_TotalPages, gint *p_NmrLine, guint p_month, guint p_year )
{
	gchar		*Str = NULL;
	gchar		*StrMonth = NULL;
	gdouble		h;
	
	h = _SIZE_ONE_PAGE_;
	
	if( (p_PosY + (_POS_LINE_Y_ * 4)) >= (*p_TotalPages * h )) {
		
		page_create();
		page_list_alloc( NOUVELLE_PAGE );
		
		StrMonth = libutils_string_toupper( libutils_get_str_month( p_month ));
		Str = g_strdup_printf( "%s %d", StrMonth, p_year );
		*(p_NmrLine) += 2;
		page_add_font_color( COLOR_BLACK );
		page_add_font_slant( FONT_SLANT_NORMAL );
		page_add_font_weight( FONT_WEIGHT_BOLD );
		page_add_str( Str );
		
		g_free( StrMonth );
		StrMonth = NULL;
		g_free( Str );
		Str = NULL;

		page_add_PosX( 55 );
				
		p_PosY =  *p_TotalPages * h;
		p_PosY += _POS_LINE_Y_BEGIN_PAGE_;
		p_PosY += _POS_LINE_Y_;
		
		page_add_PosY( p_PosY );
		
// ------------------------------------------------------------
// NUMERO DE PAGE EN HAUT
// ------------------------------------------------------------
		/*Page_list_alloc( STRING_PAGE );
		Str = g_strdup_printf( _("Page %d"), *p_TotalPages +1 );
		Page_add_str( Str );
		g_free( Str );
		Str = NULL;
		Page_add_posX( 500 );
		Page_add_posY( p_PosY );
		Page_add_font_slant( FONT_SLANT_ITALIC );
		Page_add_font_weight( FONT_WEIGHT_BOLD );*/
		
		// Page_list_alloc( LINE_GRAPH );
		page_list_alloc( LINE_GRAPH );
		page_add_line( 55.0, p_PosY + 10.0, 485.0 );
// ------------------------------------------------------------
// NUMERO DE PAGE EN BAS
// ------------------------------------------------------------
		page_list_alloc( STRING_PAGE );
		
		Str = g_strdup_printf( _("Page %d"), *p_TotalPages +1 );
		page_add_str( Str );
		g_free( Str );
		Str = NULL;
		page_add_PosX( 500 );
		page_add_PosY( ((*p_TotalPages * h) + h) -_POS_LINE_Y_ );
		page_add_font_slant( FONT_SLANT_ITALIC );
		page_add_font_weight( FONT_WEIGHT_BOLD );
		
		page_list_alloc( LINE_GRAPH );
		page_add_line( 55.0, ((*p_TotalPages * h) + h) - (_POS_LINE_Y_ * 2.), 485.0 );
		
// ------------------------------------------------------------
		p_PosY += _POS_LINE_Y_ * 2;

		*(p_TotalPages) += 1;
		if( *p_TotalPages > 1 ) *(p_NmrLine) += 1;
		
		*(p_NmrLine) += 2;
	}
	return( p_PosY );
}
// 
// CONSTRUCTION DE LA LISTE D'IMPRESSION: ECRAN, PS, PDF, TXT
// 
gint file_make_list( void )
{
	gchar		*Str = NULL;
	gint		DayBegin, DayEnd;
	guint 		year, month, day, Dday;
	gint		Hours = 0;
	gint		Minutes = 0;
	gint		TotalHoursMonth = 0;
	gdouble		LocateX = 55.0;
	gint		LineInOnePage = 0;
	gint		TotalPages = 0;
	gdouble		PosY = 0.0;
	TYPE_COLOR	TypeColor;
		
	// REMOVE LIST
	page_list_remove();
	// 
	gtk_calendar_get_date( GTK_CALENDAR(VarCallbacks.Adr_Calendar), &year, &month, &Dday );
	if( VarEdit.YearEdit != year ) return( 0 );
	libutils_get_base_days_in_month( month, year, &DayBegin, &DayEnd );
	DayBegin --;
	DayEnd --;
	
	// CALCUL HEURES PAR SEMAINE ET HEURES SUPERIEURES A HEURES_NORMALES_SEMAINE
	file_get_overtime();
		
	for( day = 1; DayBegin < DayEnd; DayBegin ++, day ++ ) {
		
		TypeColor = COLOR_BLACK;
		
		PosY = file_test_is_new_page( PosY, &TotalPages, &LineInOnePage, month, year );
		
		if( FALSE == VarDraw.BoolSaveToFile ) {
			// INDIQUE SI JOURNEE ACTUELLE
			if( day == Dday ) {
				TypeColor = COLOR_RED;
				page_list_alloc( STRING_REPAIR );
				page_add_font_color( TypeColor );
				page_add_font_slant( FONT_SLANT_NORMAL );
				page_add_str( "[*]" );
				page_add_PosX( LocateX -20 );
				page_add_PosY( PosY + _POS_LINE_Y_ );
			}
		}
		
		TotalHoursMonth += (VarEdit.Day[ DayBegin ].MatinFin  - VarEdit.Day[ DayBegin ].MatinDebut) + (VarEdit.Day[ DayBegin ].SoirFin - VarEdit.Day[ DayBegin ].SoirDebut);
		Hours            = ((VarEdit.Day[ DayBegin ].MatinFin - VarEdit.Day[ DayBegin ].MatinDebut) + (VarEdit.Day[ DayBegin ].SoirFin - VarEdit.Day[ DayBegin ].SoirDebut)) / 60;
		Minutes          = ((VarEdit.Day[ DayBegin ].MatinFin - VarEdit.Day[ DayBegin ].MatinDebut) + (VarEdit.Day[ DayBegin ].SoirFin - VarEdit.Day[ DayBegin ].SoirDebut)) % 60;
		
		Str = g_strdup_printf( "%02d      %s",
			libutils_get_weeks( VarEdit.Day[ DayBegin ].Day, VarEdit.Day[ DayBegin ].Month, VarEdit.YearEdit ),
			libutils_get_day( VarEdit.Day[ DayBegin ].ThisDay -1 )
			);
		LineInOnePage ++;
		PosY = file_test_is_new_page( PosY, &TotalPages, &LineInOnePage, month, year );
		page_list_alloc( STRING );
		page_add_font_color( TypeColor );
		page_add_font_slant( FONT_SLANT_NORMAL );
		page_add_str( Str );
		page_add_PosX( LocateX );
		PosY = page_add_PosY( PosY + _POS_LINE_Y_ );
		g_free( Str );
		Str = NULL;
		
		Str = g_strdup_printf( "%02d        %02d:%02d  %02d:%02d        %02d:%02d  %02d:%02d        %02d:%02d",
			day,
			
			VarEdit.Day[ DayBegin ].MatinDebut / 60,
			VarEdit.Day[ DayBegin ].MatinDebut % 60,
			
			VarEdit.Day[ DayBegin ].MatinFin / 60,
			VarEdit.Day[ DayBegin ].MatinFin % 60,
			
			VarEdit.Day[ DayBegin ].SoirDebut / 60,
			VarEdit.Day[ DayBegin ].SoirDebut % 60,
			
			VarEdit.Day[ DayBegin ].SoirFin / 60,
			VarEdit.Day[ DayBegin ].SoirFin % 60,
			
			Hours, Minutes
			);
		
		page_list_alloc( STRING );
		page_add_font_color( TypeColor );
		page_add_font_slant( FONT_SLANT_NORMAL );
		page_add_str( Str );
		g_free( Str );
		Str = NULL;
		page_add_PosX( LocateX + 70 );
		PosY = page_add_PosY( PosY  );
		
		// COMMENTAIRE
		{
		if( NULL != VarEdit.Day[ DayBegin ].LongComment && *VarEdit.Day[ DayBegin ].LongComment->str != '\0' ) {
			
			gchar	**LarrbufLine = NULL;
			gint	IndiceComment;

			LarrbufLine = g_strsplit( VarEdit.Day[ DayBegin ].LongComment->str, "\n", 0 );
	
			for( IndiceComment = 0; LarrbufLine[ IndiceComment ]; IndiceComment ++ ) {
				LineInOnePage ++;
				PosY = file_test_is_new_page( PosY, &TotalPages, &LineInOnePage, month, year );
				page_list_alloc( STRING_COMMENT );
				page_add_font_color( COLOR_BLACK );
				page_add_font_slant( FONT_SLANT_ITALIC );
				page_add_str( LarrbufLine[ IndiceComment ] );
				page_add_PosX( LocateX + 200 );
				PosY = page_add_PosY( PosY + _POS_LINE_Y_ );
			}
	
			g_strfreev( LarrbufLine );
			LarrbufLine = NULL;
		}
		}
		
		if( VarEdit.Day[ DayBegin ].ThisDay == 7 ) {

			// AFFICHE LE NUMERO DE SEMAINE
			// Str = g_strdup_printf( "             [ semaine ] %02d\n", EditYear_get_weeks( VarEdit.Day[ DayBegin ].Day, VarEdit.Day[ DayBegin ].Month, VarEdit.YearEdit ));
			// g_free( Str );
			// Str = NULL;

			// HEURES DE LA SEMAINE
			Str = g_strdup_printf( "heures:" );
			LineInOnePage ++;
			PosY = file_test_is_new_page( PosY, &TotalPages, &LineInOnePage, month, year );
			page_list_alloc( STRING );
			page_add_font_color( COLOR_BLACK );
			page_add_font_slant( FONT_SLANT_NORMAL );
			page_add_font_weight( FONT_WEIGHT_BOLD );
			page_add_str( Str );
			g_free( Str );
			Str = NULL;
			page_add_PosX( LocateX + 100 );
			PosY = page_add_PosY( PosY + _POS_LINE_Y_ );
			
			Str = g_strdup_printf( "%02dh%02d", VarEdit.Day[ DayBegin ].WorkingTime / 60, VarEdit.Day[ DayBegin ].WorkingTime % 60 );
			
			page_list_alloc( STRING );
			page_add_font_color( COLOR_BLACK );
			page_add_font_slant( FONT_SLANT_NORMAL );
			page_add_font_weight( FONT_WEIGHT_BOLD );
			page_add_str( Str );
			g_free( Str );
			Str = NULL;
			page_add_PosX( LocateX + 150 );
			PosY = page_add_PosY( PosY );

			// HEURES SUPERIEURE A HEURES_NORMALES_SEMAINE
			if( VarEdit.Day[ DayBegin ].OverTime > 0 ) {
				Str = g_strdup_printf( "sup.:" );
				LineInOnePage ++;
				PosY = file_test_is_new_page( PosY, &TotalPages, &LineInOnePage, month, year );
				page_list_alloc( STRING );
				page_add_font_color( COLOR_BLACK );
				page_add_font_slant( FONT_SLANT_NORMAL );
				page_add_font_weight( FONT_WEIGHT_BOLD );
				page_add_str( Str );
				g_free( Str );
				Str = NULL;
				page_add_PosX( LocateX + 100 );
				PosY = page_add_PosY( PosY + _POS_LINE_Y_ );
				
				Str = g_strdup_printf( "%02dh%02d", VarEdit.Day[ DayBegin ].OverTime / 60, VarEdit.Day[ DayBegin ].OverTime % 60 );
				page_list_alloc( STRING );
				page_add_font_color( COLOR_BLACK );
				page_add_font_slant( FONT_SLANT_NORMAL );
				page_add_font_weight( FONT_WEIGHT_BOLD );
				page_add_str( Str );
				g_free( Str );
				Str = NULL;
				page_add_PosX( LocateX + 150 );
				PosY = page_add_PosY( PosY );
			}
			PosY += _POS_LINE_Y_;
			
			LineInOnePage ++;
			PosY = file_test_is_new_page( PosY, &TotalPages, &LineInOnePage, month, year );
		}
	}
	
	Str = g_strdup_printf(  "Total heures du mois: %02dh%02d", TotalHoursMonth / 60, TotalHoursMonth % 60 );
	LineInOnePage ++;
	PosY = file_test_is_new_page( PosY, &TotalPages, &LineInOnePage, month, year );
	LineInOnePage ++;
	PosY = file_test_is_new_page( PosY, &TotalPages, &LineInOnePage, month, year );
	page_list_alloc( STRING );
	page_add_font_color( COLOR_BLACK );
	page_add_font_slant( FONT_SLANT_NORMAL );
	page_add_font_weight( FONT_WEIGHT_BOLD );
	page_add_str( Str );
	g_free( Str );
	Str = NULL;	
	page_add_PosX( LocateX + 30 );
	PosY = page_add_PosY( PosY + _POS_LINE_Y_ + _POS_LINE_Y_ );
	
	if( TotalPages != VarDraw.TotalPages ) {
		callbacks_alloc_page( TotalPages );
		draw_set_size_request();
	}

	return( TotalPages );
}
// 
// 
void file_remove_struct_year( void )
{
	gint	Day;
	
	if( NULL != VarEdit.Day ) {
		// REMOVE LongComment
		for( Day = 0; Day < VarEdit.NbrJoursAnnee; Day ++ ) {
			if( NULL != VarEdit.Day[ Day ].LongComment ) {
				g_string_free( VarEdit.Day[ Day ].LongComment, TRUE );
			}
		}
		// REMOVE Struct
		g_free( VarEdit.Day );
		VarEdit.Day = NULL;
	}
}
// 
// 
void file_remove_struct_all( void )
{
	gint	Day;

	file_remove_struct_year();

	if( NULL != VarEdit.DayAdjust ) {
		// REMOVE LongComment
		for( Day = 0; Day < MAX_DAY_ADJUST; Day ++ ) {
			if( NULL != VarEdit.DayAdjust[ Day ].LongComment ) {
				g_string_free( VarEdit.DayAdjust[ Day ].LongComment, TRUE );
			}
		}
		// REMOVE Struct
		g_free( VarEdit.DayAdjust );
		VarEdit.DayAdjust = NULL;
	}
}
// 
// 
void file_alloc_struct( void )
{
	gint	weekday;
	gint	Day;
	gint	Month;
	gint	NbrMonth;
	gint	Indice;
	
	file_remove_struct_year();
	
	// TOTAL NUMBER DAYS OF YEAR	
	VarEdit.NbrJoursAnnee = libutils_get_nbr_days_of_year( VarEdit.YearEdit );
	
	// ALOCATE STRUCT
	VarEdit.Day = (VAR_EDIT_DAY *)g_malloc0( sizeof(VAR_EDIT_DAY) * (VarEdit.NbrJoursAnnee +10) );
	
	weekday = libutils_get_weekday( 1, 1, VarEdit.YearEdit );
	
	// INIT STRUCT
	// Day = 0 .. VarEdit.NbrJoursAnnee
	Day = 0;
	
	// POUR TOUS LES MOIS
	for( Month = 1; Month <= 12; Month ++ ) {
		// POUR TOUS LES JOURS DU MOIS
		NbrMonth = libutils_get_days_in_month( Month, VarEdit.YearEdit );
		for( Indice = 1; Indice <= NbrMonth; Indice ++ ) {
			
			if( weekday > 7 ) weekday = 1;
		
			VarEdit.Day[ Day ].IndiceJour       = Day;	// 0 .. VarEdit.NbrJoursAnnee -1
			VarEdit.Day[ Day ].ThisDay          = weekday;	// 1=LUNDI .. 7=DIMANCHE
			VarEdit.Day[ Day ].Day              = Indice;	// 1 .. 31
			VarEdit.Day[ Day ].Month            = Month;	// 1=JANVIER .. 12=DECEMBRE
			VarEdit.Day[ Day ].WorkingTime      = 0;	// Heures de la semaine stockees le dimanche
			VarEdit.Day[ Day ].OverTime         = 0;	// Heures superieures a HEURES_NORMALES_SEMAINE stockees le dimanche
			VarEdit.Day[ Day ].LongComment      = g_string_new( NULL );
			
			if( weekday >= 6 ) {
				VarEdit.Day[ Day ].MatinDebut       = 0;
				VarEdit.Day[ Day ].MatinFin         = 0;
				VarEdit.Day[ Day ].SoirDebut        = 0;
				VarEdit.Day[ Day ].SoirFin          = 0;
			}
			else {
				VarEdit.Day[ Day ].MatinDebut       = 450;
				VarEdit.Day[ Day ].MatinFin         = 690;
				VarEdit.Day[ Day ].SoirDebut        = 720;
				VarEdit.Day[ Day ].SoirFin          = 975;
			}
			if( weekday == 5 ) {
				VarEdit.Day[ Day ].MatinDebut       = 450;
				VarEdit.Day[ Day ].MatinFin         = 690;
				VarEdit.Day[ Day ].SoirDebut        = 690;
				VarEdit.Day[ Day ].SoirFin          = 690;
			}
			
			weekday ++;
			Day ++;
		}
	}
}
// 
// FIXME: CONVERSION ANCIENNE BASE (tm v 0.0.6) VERS NOUVELLE BASE
// BOUCLE SUR VarEdit.Larrbuf
// TRANSFORMATION DU COMMENTAIRE EN POSITION 6 VERS COMMENT X comment ...
// FIN DE BOUCLE
// 
void file_old_to_new_base( gchar *p_PathNameFileBase )
{
	FILE		*fp = NULL;
	gchar		**LarrbufLine = NULL;
	size_t 		SizeFile;
	gchar		*Buffer = NULL;
	gint		Cpt;
	gchar		*Ptr = NULL;
	gboolean	BoolAllocStruct = FALSE;
	gint		IndiceComment;
	
	// VERIFY HEADER
	VarEdit.Larrbuf = NULL;
	if(( SizeFile = libutils_get_size_file( p_PathNameFileBase )) > 0 ) {
		if( NULL != ( fp = fopen( p_PathNameFileBase, "r" ))) {
			Buffer = (gchar *)g_malloc0( sizeof(gchar) * ( SizeFile +10 ));
			SizeFile = fread( Buffer, SizeFile, 1, fp );
			fclose( fp );
			VarEdit.Larrbuf = g_strsplit( Buffer, "\n", 0 );
			g_free( Buffer );
			Buffer = NULL;
		}
	}
	
	// VERIFY FILE FOR TM
	for( Cpt = 0; VarEdit.Larrbuf[ Cpt ]; Cpt++ ) {
		
		if( strncmp( VarEdit.Larrbuf[ Cpt ], "# Datas for tm program", 22 ) == 0 ) {
			BoolAllocStruct = TRUE;
			break;
		}
	}
	
	if( FALSE == BoolAllocStruct ) {
	
		g_strfreev( VarEdit.Larrbuf );
		VarEdit.Larrbuf = NULL;
		return;
	}
	
	BoolAllocStruct = FALSE;
	// READ: YEAR
	// ALLOCATE STRUCT WITH: NUMBER_DAY
	for( Cpt = 0; VarEdit.Larrbuf[ Cpt ]; Cpt++ ) {
		
		// Si commentaire ou ligne vide alors ligne suivante
		if( *VarEdit.Larrbuf[ Cpt ] == '#' || *VarEdit.Larrbuf[ Cpt ] == '\0') continue;
		
		if( strncmp( VarEdit.Larrbuf[ Cpt ], "YEAR", 4 ) == 0 ) {
			Ptr = VarEdit.Larrbuf[ Cpt ];
			VarEdit.YearEdit = (guint)atoi( (Ptr +5) );
			file_alloc_struct();
			BoolAllocStruct = TRUE;
			break;
		}
	}
	
	if( FALSE == BoolAllocStruct ) {
	
		g_strfreev( VarEdit.Larrbuf );
		VarEdit.Larrbuf = NULL;
		return;
	}
	
	BoolAllocStruct = FALSE;
	// TEST INTEGRAL DE LA VALIDITE DU FICHIER
	for( Cpt = 0; VarEdit.Larrbuf[ Cpt ]; Cpt++ ) {
	
		// Si commentaire ou ligne vide alors ligne suivante
		if( *VarEdit.Larrbuf[ Cpt ] == '#' || *VarEdit.Larrbuf[ Cpt ] == '\0') continue;

		if( strncmp( VarEdit.Larrbuf[ Cpt ], "DAY", 3 ) == 0 ) {
			// LINE SPLIT
			//	0: DAY
			//	1: MATIN DEBUT
			//	2: MATIN FIN
			//	3: SOIR DEBUT
			//	4: SOIR FIN
			LarrbufLine = g_strsplit( VarEdit.Larrbuf[ Cpt ], " ", 0 );
			
			if( LarrbufLine[ 0 ] && LarrbufLine[ 1 ] && LarrbufLine[ 2 ] && LarrbufLine[ 3 ] && LarrbufLine[ 4 ]  && LarrbufLine[ 5 ] ) {
				BoolAllocStruct = TRUE;
			}
			else {
				BoolAllocStruct = FALSE;
				g_strfreev( LarrbufLine );
				LarrbufLine = NULL;
				break;
			}
			
			g_strfreev( LarrbufLine );
			LarrbufLine = NULL;
		}
	}
	
	if( FALSE == BoolAllocStruct ) {
		g_strfreev( VarEdit.Larrbuf );
		VarEdit.Larrbuf = NULL;
		return;
	}
	
	if( NULL != (fp = fopen( p_PathNameFileBase, "w" ))) {
		
		for( Cpt = 0; VarEdit.Larrbuf[ Cpt ]; Cpt++ ) {
			if( strncmp( VarEdit.Larrbuf[ Cpt ], "DAY", 3 ) == 0 ) {
		
				LarrbufLine = g_strsplit( VarEdit.Larrbuf[ Cpt ], " ", 0 );
				if( LarrbufLine[ 0 ] && LarrbufLine[ 1 ] && LarrbufLine[ 2 ] && LarrbufLine[ 3 ] && LarrbufLine[ 4 ] && LarrbufLine[ 5 ] ) {
					fprintf (fp, "THISDAY " );
					fprintf (fp, "%s ", LarrbufLine[ 1 ] );
					fprintf (fp, "%s ", LarrbufLine[ 2 ] );
					fprintf (fp, "%s ", LarrbufLine[ 3 ] );
					fprintf (fp, "%s ", LarrbufLine[ 4 ] );
					fprintf (fp, "%s\n",  LarrbufLine[ 5 ] );
					if( NULL != LarrbufLine[ 6 ] && *LarrbufLine[ 6 ] != '\0' ) {
						fprintf (fp, "COMMENT " );
						fprintf (fp, "%s ", LarrbufLine[ 1 ] );
						for( IndiceComment = 6; LarrbufLine[ IndiceComment ]; IndiceComment ++ ) {
							fprintf (fp, "%s", LarrbufLine[ IndiceComment ] );
							if( NULL != LarrbufLine[ IndiceComment +1 ] && *LarrbufLine[ IndiceComment +1 ] != '\0' ) {
								fprintf (fp, " " );
							}
						}
						fprintf (fp, "\n" );
					}
				
				}
			}
			else {
				// SAVE VarEdit.Larrbuf[ Cpt ]
				fprintf (fp, "%s\n", VarEdit.Larrbuf[ Cpt ] );
			}
		}
		fclose( fp );
	}

	// REMOVE BUFFER OF LINE
	g_strfreev( VarEdit.Larrbuf );
	VarEdit.Larrbuf = NULL;
}
// 
// 
// 
// 
gboolean file_read( gchar *p_PathNameFileBase )
{
	FILE		*fp = NULL;
	size_t 		SizeFile;
	gchar		*Buffer = NULL;
	gint		Cpt;
	gchar		*Ptr = NULL;
	gboolean	BoolAllocStruct = FALSE;
	gchar		**LarrbufLine = NULL;
	gint		Day;
	gint		TotalPages;
	
	// ANCIENNE BASE VERS NOUVELLE BASE
	file_old_to_new_base( p_PathNameFileBase );
	
	// VERIFY HEADER
	VarEdit.Larrbuf = NULL;
	if(( SizeFile = libutils_get_size_file( p_PathNameFileBase )) > 0 ) {
		if( NULL != ( fp = fopen( p_PathNameFileBase, "r" ))) {
			Buffer = (gchar *)g_malloc0( sizeof(gchar) * ( SizeFile +10 ));
			SizeFile = fread( Buffer, SizeFile, 1, fp );
			fclose( fp );
			VarEdit.Larrbuf = g_strsplit( Buffer, "\n", 0 );
			g_free( Buffer );
			Buffer = NULL;
		}
	}
	
	// VERIFY FILE FOR TM
	for( Cpt = 0; VarEdit.Larrbuf[ Cpt ]; Cpt++ ) {
		
		if( strncmp( VarEdit.Larrbuf[ Cpt ], "# Datas for tm program", 22 ) == 0 ) {
			BoolAllocStruct = TRUE;
			break;
		}
	}
	
	if( FALSE == BoolAllocStruct ) {
		
		wininfo_create ( WindMain,
			_("Erreur choix de fichier !"),
			_("   Ce fichier ne correspond pas     "),
			  "\n",
			_("   a l'application"),
			  "\n",
			_("   Time Management"),
			  "\n\n",
			_("   Veuillez recommencer."),
			  "\n",
			  "");
	
		g_strfreev( VarEdit.Larrbuf );
		VarEdit.Larrbuf = NULL;
		return( FALSE );
	}
	
	BoolAllocStruct = FALSE;
	// READ: YEAR
	// ALLOCATE STRUCT WITH: NUMBER_DAY
	for( Cpt = 0; VarEdit.Larrbuf[ Cpt ]; Cpt++ ) {
		
		// Si commentaire ou ligne vide alors ligne suivante
		if( *VarEdit.Larrbuf[ Cpt ] == '#' || *VarEdit.Larrbuf[ Cpt ] == '\0') continue;
		
		if( strncmp( VarEdit.Larrbuf[ Cpt ], "YEAR", 4 ) == 0 ) {
			Ptr = VarEdit.Larrbuf[ Cpt ];
			VarEdit.YearEdit = (guint)atoi( (Ptr +5) );
			file_alloc_struct();
			BoolAllocStruct = TRUE;
			break;
		}
	}
	
	if( FALSE == BoolAllocStruct ) {
		
		wininfo_create ( WindMain,
			_("Erreur choix de fichier !"),
			_("   Ce fichier ne correspond pas     "),
			  "\n",
			_("   a l'application"),
			  "\n",
			_("   Time Management"),
			  "\n\n",
			_("   Veuillez recommencer."),
			  "\n",
			  "");
	
		g_strfreev( VarEdit.Larrbuf );
		VarEdit.Larrbuf = NULL;
		return( FALSE );
	}
	
	BoolAllocStruct = FALSE;
	// TEST INTEGRAL DE LA VALIDITE DU FICHIER
	for( Cpt = 0; VarEdit.Larrbuf[ Cpt ]; Cpt++ ) {
	
		// Si commentaire ou ligne vide alors ligne suivante
		if( *VarEdit.Larrbuf[ Cpt ] == '#' || *VarEdit.Larrbuf[ Cpt ] == '\0') continue;

		if( strncmp( VarEdit.Larrbuf[ Cpt ], "THISDAY", 7 ) == 0 ) {
			// LINE SPLIT
			//	0: DAY
			//	1: MATIN DEBUT
			//	2: MATIN FIN
			//	3: SOIR DEBUT
			//	4: SOIR FIN
			LarrbufLine = g_strsplit( VarEdit.Larrbuf[ Cpt ], " ", 0 );
			
			if( LarrbufLine[ 0 ] && LarrbufLine[ 1 ] && LarrbufLine[ 2 ] && LarrbufLine[ 3 ] && LarrbufLine[ 4 ]  && LarrbufLine[ 5 ] ) {
				BoolAllocStruct = TRUE;
			}
			else {
				g_print("VarEdit.Larrbuf[ Cpt ] = %s\n", VarEdit.Larrbuf[ Cpt ] );
				BoolAllocStruct = FALSE;
				g_strfreev( LarrbufLine );
				LarrbufLine = NULL;
				break;
			}
			
			g_strfreev( LarrbufLine );
			LarrbufLine = NULL;
		}
	}
	
	
	if( FALSE == BoolAllocStruct ) {
		
		wininfo_create ( WindMain,
			_("Fichier corrompu !"),
			_("La structure du fichier est corrompue !"),
			  "\n",
			  "");
	
		g_strfreev( VarEdit.Larrbuf );
		VarEdit.Larrbuf = NULL;
		return( FALSE );
	}
	
	// 
	// YEAR 2012
	// NUMBER_DAY  366
	// 
	// THISDAY 1 190 690 720 975
	// THISDAY 2 191 690 720 975
	// 
	
	for( Cpt = 0; VarEdit.Larrbuf[ Cpt ]; Cpt++ ) {
		
		// Si commentaire ou ligne vide alors ligne suivante
		if( *VarEdit.Larrbuf[ Cpt ] == '#' || *VarEdit.Larrbuf[ Cpt ] == '\0') continue;

		if( strncmp( VarEdit.Larrbuf[ Cpt ], "THISDAY", 7 ) == 0 ) {
			
			// LINE SPLIT
			//	0: DAY
			//	1: MATIN DEBUT
			//	2: MATIN FIN
			//	3: SOIR DEBUT
			//	4: SOIR FIN
			LarrbufLine = g_strsplit( VarEdit.Larrbuf[ Cpt ], " ", 0 );
			
			if( LarrbufLine[ 0 ] && LarrbufLine[ 1 ] && LarrbufLine[ 2 ] && LarrbufLine[ 3 ] && LarrbufLine[ 4 ]  && LarrbufLine[ 5 ] ) {
				/*g_print( "1>%s  2>%s  3>%s  4>%s  5>%s  6>%s\n",
					LarrbufLine[ 0 ],	// STRING DAY
					LarrbufLine[ 1 ],	// NUMBER OF DAY
					LarrbufLine[ 2 ],	// MATIN DEBUT
					LarrbufLine[ 3 ],	// MATIN FIN
					LarrbufLine[ 4 ],	// SOIR DEBUT
					LarrbufLine[ 5 ]	// SOIR FIN
					);*/
				
				Day = atoi( LarrbufLine[ 1 ] );
				
				VarEdit.Day[ Day ].MatinDebut = atoi( LarrbufLine[ 2 ] );
				VarEdit.Day[ Day ].MatinFin   = atoi( LarrbufLine[ 3 ] );
				if( VarEdit.Day[ Day ].MatinFin < VarEdit.Day[ Day ].MatinDebut )
					VarEdit.Day[ Day ].MatinFin = VarEdit.Day[ Day ].MatinDebut;
				
				VarEdit.Day[ Day ].SoirDebut  = atoi( LarrbufLine[ 4 ] );
				VarEdit.Day[ Day ].SoirFin    = atoi( LarrbufLine[ 5 ] );
				if( VarEdit.Day[ Day ].SoirFin < VarEdit.Day[ Day ].SoirDebut )
					VarEdit.Day[ Day ].SoirFin = VarEdit.Day[ Day ].SoirDebut;
				
			}
			g_strfreev( LarrbufLine );
			LarrbufLine = NULL;
		}
		// THISDAY
		// COMMENT
		else if( strncmp( VarEdit.Larrbuf[ Cpt ], "COMMENT", 7 ) == 0 ) {
			
			gint	IndiceComment;
			static gint OldDay = -1;
			
			LarrbufLine = g_strsplit( VarEdit.Larrbuf[ Cpt ], " ", 0 );
			Day = atoi( LarrbufLine[ 1 ] );
			
			if( OldDay != -1 && Day != OldDay ) OldDay = -1;
			
			if( OldDay == -1 ) {
				if( NULL != VarEdit.Day[ Day ].LongComment ) {
					g_string_free( VarEdit.Day[ Day ].LongComment, TRUE );
					VarEdit.Day[ Day ].LongComment = g_string_new( NULL );	
				}
			} else
			{
				g_string_append_printf( VarEdit.Day[ Day ].LongComment, "\n" );
			}
			for( IndiceComment = 2; LarrbufLine[ IndiceComment ]; IndiceComment ++ ) {
				g_string_append_printf( VarEdit.Day[ Day ].LongComment, "%s%s",
							LarrbufLine[ IndiceComment ],
							LarrbufLine[ IndiceComment +1 ] ? " " : ""
							);
			}
			
			g_strfreev( LarrbufLine );
			LarrbufLine = NULL;
			
			OldDay = Day;
		}
			
	}
	g_strfreev( VarEdit.Larrbuf );
	VarEdit.Larrbuf = NULL;
	
	TotalPages = file_make_list();
	callbacks_alloc_page( TotalPages );
	draw_set_size_request();
	
	return( TRUE );
}
// 
// 
void file_save_struct( SAVE_FILE_TYPE p_TypeFileSave )
{
	FILE	*fp = NULL;
	gint	Day;
	gchar	**LarrbufLine = NULL;
	
	if( NULL == VarEdit.Day ) return;
	if( FORCE_SAVE_FILE == p_TypeFileSave ) VarEdit.BoolEdit = TRUE;
	if( FALSE == VarEdit.BoolEdit ) return;
	
	if( NULL != (fp = fopen( Config.PathNameFileBase, "w" ))) {
		
		// PRINT_FUNC_LF();
		
		// AM	AVANT Midi
		// PM	APRES Midi
		fprintf (fp, "# \n" );
		fprintf (fp, "# Datas for tm program\n" );
		fprintf (fp, "# \n" );
		fprintf (fp, "# copyright : (C) 2012 by Claude BULIN\n" );
		fprintf (fp, "# Time Management - Edition des heures de travail / Edition of working hours\n" );
		fprintf (fp, "# GNU General Public License\n" );
		fprintf (fp, "# \n" );
		fprintf (fp, "# THISDAY DAY AM_TIME_BEGIN_IN_MINUTES AM_TIME_END_IN_MINUTES PM_TIME_BEGIN_IN_MINUTES PM_TIME_END_IN_MINUTES\n" );
		fprintf (fp, "# COMMENT DAY COMMENT\n" );
		fprintf (fp, "# \n" );
		fprintf (fp, "\n" );
		fprintf (fp, "YEAR %d\n", VarEdit.YearEdit );
		fprintf (fp, "NUMBER_DAY %d\n", VarEdit.NbrJoursAnnee );
		fprintf (fp, "\n" );
		
		// INIT STRUCT
		
		// THISDAY 1 190 690 720 975
		// THISDAY 2 191 690 720 975

		for( Day = 0; Day < VarEdit.NbrJoursAnnee; Day ++ ) {
			
			fprintf (fp, "THISDAY " );
			fprintf (fp, "%d ", VarEdit.Day[ Day ].IndiceJour );
			fprintf (fp, "%d ", VarEdit.Day[ Day ].MatinDebut );
			fprintf (fp, "%d ", VarEdit.Day[ Day ].MatinFin );
			fprintf (fp, "%d ", VarEdit.Day[ Day ].SoirDebut );
			fprintf (fp, "%d", VarEdit.Day[ Day ].SoirFin );
			fprintf (fp, "\n" );
			if( NULL != VarEdit.Day[ Day ].LongComment ) {

				gint	IndiceComment;
				
				LarrbufLine = g_strsplit( VarEdit.Day[ Day ].LongComment->str, "\n", 0 );
				
				for( IndiceComment = 0; LarrbufLine[ IndiceComment ]; IndiceComment ++ ) {
					fprintf (fp, "COMMENT " );
					fprintf (fp, "%d ", VarEdit.Day[ Day ].IndiceJour );
					fprintf (fp, "%s",  LarrbufLine[ IndiceComment ] );
					fprintf (fp, "\n" );
				}
				
				g_strfreev( LarrbufLine );
				LarrbufLine = NULL;
			}
		}
		fclose( fp );
		VarEdit.BoolEdit = FALSE;
		edit_set_flag_buttons();
	}
}

